unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, XPMan, Buttons, ImgList, dxSkinsCore,
  dxSkinDarkSide, cxLookAndFeels, dxSkinsForm, Menus,
  cxLookAndFeelPainters, cxButtons;

type
  TForm2 = class(TForm)
    Image1: TImage;
    XPManifest1: TXPManifest;
    Timer1: TTimer;
    ImageList1: TImageList;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    cxButton1: TcxButton;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cxButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  i,j,count,m:integer;   //
  xcur,ycur, grad: Integer;    // 
  len,clr,wid: Integer;     // 
  skip: integer;       //  
  switch: boolean;

implementation

uses Unit1, Unit3, Unit4;

{$R *.dfm}

function krai: boolean;
begin
  case grad of
  0:  if ycur-len < 0 then krai:=true else krai:=false;
  90: if xcur+len > Form2.Width then krai:=true else krai:=false;
  180: if ycur+len > Form2.Height then krai:=true else krai:=false;
  270: if xcur-len <0 then krai:= true else krai:=false;
  end;
end;


procedure TurnLeft;
begin
  grad:=grad-90;
  if grad<0 then grad:=270;
  case grad of
  0: Form2.Image1.Picture:=Form2.Image4.Picture;
  90: Form2.Image1.Picture:=Form2.Image2.Picture;
  180: Form2.Image1.Picture:=Form2.Image3.Picture;
  270: Form2.Image1.Picture:=Form2.Image5.Picture;
  end;
end;

procedure TurnRight;
begin
  grad:=grad+90;
  if grad=360 then grad:=0;
  case grad of
  0: Form2.Image1.Picture:=Form2.Image4.Picture;
  90: Form2.Image1.Picture:=Form2.Image2.Picture;
  180: Form2.Image1.Picture:=Form2.Image3.Picture;
  270: Form2.Image1.Picture:=Form2.Image5.Picture;
  end;
end;


procedure Go;
begin
  //Form2.Canvas.Pen.Width:=wid;
  case grad of
  0:
    begin
      if Form2.Image1.Top-len > 0 then
    begin
      Form2.Image1.Top:=Form2.Image1.Top-len;
      Form2.Canvas.MoveTo(xcur, ycur);
      Form2.Canvas.LineTo(xcur, ycur-len);
      ycur:=ycur-len;
     end;
    end;
  90:
    begin
    if Form2.Image1.Left+len*2 < Form2.Width-len then
    begin
      Form2.Image1.Left:=Form2.Image1.Left+len;
      Form2.Canvas.MoveTo(xcur,ycur);
      Form2.Canvas.LineTo(xcur+len, ycur);
      xcur:=xcur+len;
    end;
    end;
  180:
    begin
    if Form2.Image1.Top+len*2 < Form2.Height then
    begin
      Form2.Image1.Top:=Form2.Image1.Top+len;
      Form2.Canvas.MoveTo(xcur, ycur);
      Form2.Canvas.LineTo(xcur, ycur+len);
      ycur:=ycur+len;
     end;
    end;
  270:
    begin
      if Form2.Image1.Left-len > -1 then
    begin
      Form2.Image1.Left:=Form2.Image1.Left-len;
      Form2.Canvas.MoveTo(xcur,ycur);
      Form2.Canvas.LineTo(xcur-len, ycur);
      xcur:=xcur-len;
    end;
    end;
  end;
end;

procedure Jump;
begin
  case grad of
  0:
  if Form2.Image1.Top-len > 0 then
  begin
    ycur:=ycur-len;
    Form2.Image1.Top:=Form2.Image1.Top-len;
  end;
  90:
  if Form2.Image1.Left+len < Form2.Width-len*2 then
  begin
    xcur:=xcur+len;
    Form2.Image1.Left:=Form2.Image1.Left+len;
  end;
  180:
  if Form2.Image1.Top+len*2 < Form2.Height then
  begin
    ycur:=ycur+len;
    Form2.Image1.Top:=Form2.Image1.Top+len;
  end;
  270:
  if Form2.Image1.Left-len > 0 then
  begin
    xcur:=xcur-len;
    Form2.Image1.Left:=Form2.Image1.Left-len;
  end;
  end;
end;



procedure Execute_proc(ss: string);
begin
  tmpcom:=ss;
    case tmpcom[3] of
    '': Go;
    '': Jump;
    '': TurnLeft;
    '': TurnRight;
    end;
end;

procedure Proc;
var name: string; dr: byte;
begin
  name:=copy(tmpcom, 8, length(tmpcom)-7);
  dr:=strtoint(copy(name, 1, 1));
  for m:=0 to 256 do
  begin
    if m=dr then
    begin
      for j:=1 to 256 do
      begin
        if length(procs[dr,j])<>0 then
          Execute_proc(procs[dr,j])
      end;
      break;
      Exit;
    end;{
    else begin
           ShowMessage('   !');
           exit;
         end; }
  end;
end;

{procedure Proc;
var u: byte;
begin
  for m:=0 to 256 do
  begin
    if procs[m, 0]=Form1.ListBox1.Items.Strings
  end;
  for j:=1 to 256 do
  begin
    Execute_proc(procs[])
  end;
end;             }

procedure Execute(dd:string);
begin
  case dd[3] of
    '': Go;
    '': Jump;
    '': TurnLeft;
    '': TurnRight;
    '': Proc;
    else ShowMessage('');
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  Form2.Canvas.Create;
  grad:=0;
  Form2.Image1.Picture:=Form2.Image4.Picture;
end;

procedure if_krai;
begin
  if copy(tmpcom, 6, 2)='' then
    if krai=true then skip:=i+1 else skip:=0 else
      if krai=false then skip:=i+1 else skip:=0;
end;


procedure Cycle;
var g: integer;  //
begin
  g:=5;
  while g<length(tmpcom)+1 do
  begin
    delete(tmpcom,g,1);
    if tmpcom[g]<>' ' then g:=g+1;
  end;
  if strtoint(Copy(tmpcom, 5, Length(tmpcom)-4))-1 < 0 then
  begin
    ShowMessage(' !');
    Form2.Close;
  end;
  for count:=1 to strtoint(Copy(tmpcom, 5, Length(tmpcom)-4))-1 do
    Execute(Form1.Memo1.Lines.Strings[i+1]);
end;


procedure draw;
begin
  for i:=0 to Form1.Memo1.Lines.Count-1 do
  if skip<>i then
  begin
      tmpcom:=Form1.Memo1.Lines.Strings[i];
      case tmpcom[3] of
      '': Go;
      '': Jump;
      '': TurnLeft;
      '': TurnRight;
      '': Proc;
      '': if_krai;
      '': Cycle;
      else Continue;
  end;
  end else Continue;
end;



procedure TForm2.FormPaint(Sender: TObject);
begin
   for i:=0 to Form1.Memo1.Lines.Count-1 do
  begin
    tmpcom:=Form1.Memo1.Lines.Strings[i];
    if length(tmpcom)<3 then Form1.Memo1.Lines.Delete(i);
  end;
  tmpcom:='';
 // Form2.Canvas.Pen.Width:=wid;
   //Form2.Image1.Picture.LoadFromFile('roocom_3.bmp');
  skip:=99999;
  xcur:=0;
  ycur:=0;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  cxButton1.Enabled:=false;
  xcur:=0;
  ycur:=0;
  Image1.Left:=1;
  Image1.Top:=1;
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
  37: if image1.Left-len > 0 then Image1.Left:=Image1.Left-len; //left = 37
  38: if image1.Top-len > 0 then Image1.Top:=image1.Top-len; //top = 38
  39: if image1.Left+len*2 < Form2.Width then image1.Left:=image1.Left+len; //right = 39
  40: if image1.Top +len*2 < form2.Height-len then image1.Top:=image1.Top+len; //down = 40
  114: TurnLeft;
  115: TurnRight;
  13: cxButton1.Enabled:=true;
  end;
end;


procedure TForm2.Button1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
  37: if image1.Left-len > 0 then Image1.Left:=Image1.Left-len; //left = 37
  38: if image1.Top-len > 0 then Image1.Top:=image1.Top-len; //top = 38
  39: if image1.Left+len < Form2.Width then image1.Left:=image1.Left+len; //right = 39
  40: if image1.Top +len < form2.Height-len then image1.Top:=image1.Top+len; //down = 40
  end;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  Form2.AlphaBlendValue:=0;
  Timer1.Enabled:=true;
  for i:=0 to Form1.Memo1.Lines.Count-1 do
  begin
    tmpcom:=Form1.Memo1.Lines.Strings[i];
    if length(tmpcom)<3 then Form1.Memo1.Lines.Delete(i);
  end;
  tmpcom:='';
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
  if Form2.AlphaBlendValue=255 then
  begin
    //Form2.AlphaBlendValue:=255;
    Timer1.Enabled:=false;
    Exit;
    Timer1.Free;
  end;
  Form2.AlphaBlendValue:=Form2.AlphaBlendValue+15;
end;

procedure TForm2.BitBtn1Click(Sender: TObject);
begin
  ycur:=Image1.Top-1;
  xcur:=Image1.Left-1;
  draw;
end;

procedure TForm2.cxButton1Click(Sender: TObject);
begin
  ycur:=Image1.Top-1;
  xcur:=Image1.Left-1;
  draw;
end;

end.
