unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, ColorGrd, Spin, XPMan, Buttons,
  dxSkinsCore, dxSkinDarkSide, cxControls, cxContainer, cxEdit, cxLabel,
  cxTrackBar, dxCntner, dxEditor, dxExEdtr, dxEdLib, cxTextEdit,
  cxMaskEdit, cxSpinEdit, Menus, cxLookAndFeelPainters, cxButtons;

type
  TForm4 = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    SpinEdit2: TSpinEdit;
    Timer1: TTimer;
    cxLabel1: TcxLabel;
    Red: TcxTrackBar;
    Green: TcxTrackBar;
    Blue: TcxTrackBar;
    cxSpinEdit1: TcxSpinEdit;
    cxButton1: TcxButton;
    procedure RedChange(Sender: TObject);
    procedure GreenChange(Sender: TObject);
    procedure BlueChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure cxTrackBar1PropertiesChange(Sender: TObject);
    procedure cxTrackBar2PropertiesChange(Sender: TObject);
    procedure cxTrackBar3PropertiesChange(Sender: TObject);
    procedure cxButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;
  af: longint;

implementation

uses Unit1, Unit2, Unit3;

{$R *.dfm}

procedure setcolor;
begin
  Form4.Canvas.Brush.Color:=RGB(Form4.Red.Position, Form4.Green.Position, Form4.Blue.Position);
  Form4.Canvas.Rectangle(384,88,384+41,88+33);
  //Form4.Panel1.Color := RGB( Form4.Red.Position, Form4.Green.Position, Form4.Blue.Position );
end;


procedure TForm4.RedChange(Sender: TObject);
begin
  setcolor;
end;

procedure TForm4.GreenChange(Sender: TObject);
begin
  setcolor;
end;

procedure TForm4.BlueChange(Sender: TObject);
begin
  setcolor;
end;

procedure TForm4.Button1Click(Sender: TObject);
begin
  len:=cxSpinEdit1.Value;
  wid:=SpinEdit2.Value;
  Form2.Canvas.Pen.Width:=wid;
  Form2.Canvas.Pen.Color:=Form4.Canvas.Brush.Color;
  Form1.SaveDialog1.FileName:='conf.lcf';
  begin
    Form1.SaveDialog1.Files.Clear;
    Form1.SaveDialog1.Files.Add(inttostr(len));
    Form1.SaveDialog1.Files.Add(inttostr(wid));
    Form1.SaveDialog1.Files.SaveToFile('conf.lcf');
    ShowMessage(' ');
  end;
  Close;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  Form4.Canvas.Create;
  cxSpinEdit1.Value:=len;
  SpinEdit2.Value:=wid;
  setcolor;
end;

procedure TForm4.Timer1Timer(Sender: TObject);
begin
  if Form4.AlphaBlendValue=255 then
  begin
    //Form2.AlphaBlendValue:=255;
    Form4.Timer1.Enabled:=false;
    Exit;
    Timer1.Free;
  end;
  Form4.AlphaBlendValue:=Form4.AlphaBlendValue+15;
end;

procedure TForm4.FormShow(Sender: TObject);
begin
  Form4.AlphaBlendValue:=0;
  Form4.Timer1.Enabled:=true;
end;

procedure TForm4.BitBtn1Click(Sender: TObject);
begin
  len:=cxSpinEdit1.Value;
  wid:=SpinEdit2.Value;
  Form2.Canvas.Pen.Width:=wid;
  Form2.Canvas.Pen.Color:=Form4.Canvas.Brush.Color;
  Form1.SaveDialog1.FileName:='conf.lcf';
  begin
    Form1.SaveDialog1.Files.Clear;
    Form1.SaveDialog1.Files.Add(inttostr(len));
    Form1.SaveDialog1.Files.Add(inttostr(wid));
    Form1.SaveDialog1.Files.SaveToFile('conf.lcf');
    ShowMessage(' ');
  end;
  Close;
end;

procedure TForm4.cxTrackBar1PropertiesChange(Sender: TObject);
begin
 setcolor;
end;

procedure TForm4.cxTrackBar2PropertiesChange(Sender: TObject);
begin
  setcolor;
end;

procedure TForm4.cxTrackBar3PropertiesChange(Sender: TObject);
begin
  setcolor;
end;

procedure TForm4.cxButton1Click(Sender: TObject);
begin
  len:=cxSpinEdit1.Value;
  wid:=SpinEdit2.Value;
  Form2.Canvas.Pen.Width:=wid;
  Form2.Canvas.Pen.Color:=Form4.Canvas.Brush.Color;
  Form1.SaveDialog1.FileName:='conf.lcf';
  begin
    Form1.SaveDialog1.Files.Clear;
    Form1.SaveDialog1.Files.Add(inttostr(len));
    Form1.SaveDialog1.Files.Add(inttostr(wid));
    Form1.SaveDialog1.Files.SaveToFile('conf.lcf');
    ShowMessage(' ');
  end;
  Close;
end;

end.
